unit fMain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, atScript, atScripter, IDEMain, IDEDialog,
  Vcl.StdCtrls, InspectorControls, ComponentInspector, PropertyList,
  fIDEEditor, fObjectInspector, PropertyInspEditors, ScrMemo;


type
  TfrmMain = class(TForm)
    IDEDialog: TIDEDialog;
    IDEEngine: TIDEEngine;
    IDEScripter: TIDEScripter;
    btnOpenIDE: TButton;
    procedure FormCreate(Sender: TObject);
    procedure btnOpenIDEClick(Sender: TObject);
  private
    { Private declarations }
    IDEInspector: TIDEInspector;
    fIDEInspector: TIDEInspector;
    fIDEEditorForm: TForm;
    fObjectInspector: TfmObjectInspector;
    fIDEFormDesigner: TIDEFormDesigner;
    fIDEFormDesignControl: TIDEFormDesignControl;
    function  HandleOnCallEditor(Sender: TObject; TheIndex: Integer; var EnableDefault: Boolean): Boolean;
    procedure HandleOnGetEditorClass(Sender: TObject; TheIndex: Integer; var Value: TPropertyEditorClass);
    //----IDEDialog events Handler---//
    procedure HandleOnCreateEditorEvent(Sender: TObject);
  public
    { Public declarations }
  end;




var
  frmMain: TfrmMain;

implementation
uses
 VCl.ScriptForm, StringsInspEditor, frmPropsStrings, System.TypInfo;

{$R *.dfm}

type
TCustomPropsPropertyEditor = class(TPropertyEditor)
  public
    constructor Create(AProp: TProperty); override;
    function Execute: Boolean; override;
  end;


function GetCustomProps(AInstance: TPersistent; Prop: TProperty): string;
var
  FormIntf: IScriptBasedForm;
  SValue: string;
  Strings: TStringList;
begin
  Result := '0';
  if Supports(AInstance, IScriptBasedForm, FormIntf) then
      if FormIntf.GetSaveProps.IndexOfName(Prop.FullName) > -1 then
      begin
        SValue :=  FormIntf.GetSaveProps.Values[Prop.FullName];
        if not assigned(FormIntf.GetSaveProps.Objects[Prop.Index]) then begin
           FormIntf.GetSaveProps.Objects[Prop.Index] := TStringList.Create;
           TStringList( Prop.AsObject).Text := SValue;
        end;
        Result := IntToStr(LongInt(FormIntf.GetSaveProps.Objects[Prop.Index]));
      end
      else
      begin
        SValue := EmptyStr;
        Prop.SetEmulatedOff;
        if not assigned(FormIntf.GetSaveProps.Objects[Prop.Index]) then
        begin
           FormIntf.GetSaveProps.Objects[Prop.Index] := TStringList.Create;
           TStringList( Prop.AsObject).Text := SValue;
        end;
        result :=  LongInt(FormIntf.GetSaveProps.Objects[Prop.Index]).ToString;
        Prop.SetEmulatedOn;
      end;
end;

procedure SetCustomProps(AInstance: TPersistent; Prop: TProperty; Value: string );
var
  FormIntf: IScriptBasedForm;
  Strings: TStrings;
begin
  if Supports(AInstance, IScriptBasedForm, FormIntf) then begin
     if not assigned( FormIntf.GetSaveProps.Objects[Prop.Index]) then
        FormIntf.GetSaveProps.Objects[Prop.Index] := TStringList.Create;
     TStringList( FormIntf.GetSaveProps.Objects[Prop.Index]).Text := Value;
     FormIntf.GetSaveProps.Values[Prop.FullName] := Value;
  end;
end;



procedure RegisterScriptFormCustomProps;
var
  FormClass: TScriptFormClass;
begin
  FormClass := DefaultScriptFormClass;
  RegisterCustomProperty(FormClass, 'CustomProps', TStrings.ClassInfo  , true, GetCustomProps, SetCustomProps);
end;

{ TCustomPropsPropertyEditor }

constructor TCustomPropsPropertyEditor.Create(AProp: TProperty);
begin
  inherited;
end;

function TCustomPropsPropertyEditor.Execute: Boolean;
var
 SParams: string;
 propStrings: TPersistent;
begin
     with TfrmPropStrings.Create(nil) do
     try
         propStrings := TStrings(Prop.AsObject);
         redStrings.Lines.Assign(propStrings);
         Result := ShowModal = mrOK;
         if Result then
         begin
           propStrings.Assign(redStrings.Lines);
           TScriptForm(Prop.Instance).SaveProps.Values['CustomProps'] := redStrings.Lines.Text;
         end;
     finally
       Free;
     end;

end;

{ TfrmMain }

procedure TfrmMain.btnOpenIDEClick(Sender: TObject);
begin
  IDEDialog.Execute;
end;

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  IDEDialog.OnCreateIDEForm := HandleOnCreateEditorEvent;
RegisterScriptFormCustomProps;
end;

function TfrmMain.HandleOnCallEditor(Sender: TObject; TheIndex: Integer; var EnableDefault: Boolean): Boolean;
var
 P: TProperty;
 PC: TPropertyEditorClass;
 PE: TPropertyEditor;
 propStrings: TPersistent;
 ScriptsEditor: TIDEProjectFile;
begin
    EnableDefault := TRUE;
    PC := nil;
    if assigned( TIDEInspector(Sender).OnGetEditorClass ) then
       TIDEInspector(Sender).OnGetEditorClass(TIDEInspector(Sender),TheIndex,PC);
    if not assigned(PC) then
       Exit;

    P := TIDEInspector( Sender ).Properties[TheIndex];
    if assigned(P) and ( P.TypeKind <> System.TypInfo.tkMethod ) then
    begin
          if PC = TCustomPropsPropertyEditor  then
          begin
             EnableDefault := FALSE;
             PE:=PC.Create(P);
             Result := PE.Execute;
          end;
    end;
end;

procedure TfrmMain.HandleOnCreateEditorEvent(Sender: TObject);
begin
  fIDEEditorForm := TForm(Sender);
  fObjectInspector := TfmObjectInspector( ( fIDEEditorForm as TIDEEditorForm).InspectorForm  );
  fIDEInspector := fObjectInspector.IDEInspector as TIDEInspector;

  if assigned(fIDEInspector) then begin
     fIDEInspector.OnCallEditor := HandleOnCallEditor;
     fIDEInspector.OnGetEditorClass := HandleOnGetEditorClass;
  end;
end;

procedure TfrmMain.HandleOnGetEditorClass(Sender: TObject; TheIndex: Integer; var Value: TPropertyEditorClass);
var
 P: TProperty;
begin
  Value:=nil;
  if (TheIndex >= 0 ) and ( TheIndex < TIDEInspector(Sender).PropertyCount ) then
  begin
     P := TIDEInspector(Sender).Properties[TheIndex];
     if assigned(P) then
     begin
        if SameText(P.Name, 'CustomProps') then
           Value := TCustomPropsPropertyEditor
        else if P.IsType(TypeInfo(TStrings)) {$IFDEF DELPHI9_LVL} or P.IsType(TypeInfo(TWideStrings)) {$ENDIF} then
           Value := TStringsPropertyEditor;
     end;
  end;
end;


end.
